/**
 * A Graph is a non-linear data structure consisting of nodes and edges.
 *
 * The nodes are sometimes also referred to as vertices and the edges are lines or arcs that connect any two nodes in the graph.
 *
 * ! Important: This is an impleamentation of directed graph
 */
export default class Graph<K> {
    private adList;
    /**
   * A Graph is a non-linear data structure consisting of nodes and edges.
   *
   * The nodes are sometimes also referred to as vertices and the edges are lines or arcs that connect any two nodes in the graph.
   *
   * ! Important: This is an impleamentation of directed graph
   *
   * @constructor
   * Initialize graph with a new Map(Adjacency List) of type K,K[]
   */
    constructor();
    /**
     * @property returns Adjacency List
    */
    getAdlist(): Map<K, K[]>;
    /**
     * add Node to Adjacency List with an empty array
     * @param node
     */
    addNode(node: K): void;
    /**
     * add an edge to graph going from origin to destination
     * @param origin start Node
     * @param destination destination Node
     */
    addEdge(origin: K, destination: K): void;
    /**
     * The Breadth First Search (BFS) traversal is an algorithm, which is used to visit all of the nodes of a given graph.
     *
     * In this traversal algorithm one node is selected and then all of the adjacent nodes are visited one by one.
     * @param start starting Node
     * @param find Node that is to be found
     * @returns Resultant Array containing all nodes traversed from origin to result or false to tell that bfs failed to find the connection
     */
    bfs(start: K, find: K): false | K[];
    /**
     * In this algorithm, one starting vertex is given, and when an adjacent vertex is found,
     * it moves to that adjacent vertex first and tries to traverse in the same manner.
     *
     * TODO: redo dfs for correct behavior
     * @param start starting Node
     * @param find final Node
     */
    dfs(start: K, find: K): void;
}
//# sourceMappingURL=Graph.d.ts.map