/**
 * A hash table is a data structure that is used to store keys/value pairs.
 *
 *  It uses a hash function to compute an index into an array in which an element will be inserted or searched.
 *
 * Need to specify the type for value in typescript
 */
export default class HashTable<K> {
    private data;
    /**
   * A hash table is a data structure that is used to store keys/value pairs.
   *
   *  It uses a hash function to compute an index into an array in which an element will be inserted or searched.
   *
   * @constructor Initialize Hash Table with certain memory size
   *
   * @param size numeric value for initializing hash table
   */
    constructor(size: number);
    /**
     * @private function that helps in getting a hash value
     * @param key string key that will be used for getting a numeric value
     */
    private _hash;
    /**
     * Add key/value pair to the hash table
     *
     * Time complexity-> O(1)
     * @param key key of type string
     * @param value value of type K
     */
    set(key: string, value: K): void;
    /**
     * get the value of the key/value pair in hash table
     * @param key of type string; used to get value from hash table
     *
     * @returns value of type K if found else false
     */
    get(key: string): false | K;
    /**
     * @returns all the keys of hash table as a string array
     */
    keys(): string[];
}
//# sourceMappingURL=HashTable.d.ts.map